#include <bits/stdc++.h>
#define long long long int
using namespace std;

// @author: pashka

long MOD = 998244353;

int main() {
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    long res = 1;
    for (int ttt = 0; ttt < 2; ttt++) {
        for (int i = 0; i < n; i++) {
            for (int l = 0; l < n; l++) {
                if (a[i][l] == '?' && (l == 0 || a[i][l - 1] != '?')) {
                    int r = l;
                    while (r < n && a[i][r] == '?') r++;
                    int d = r - l;
                    bool x = l > 0 && a[i][l - 1] == '#';
                    bool y = r < n && a[i][r] == '#';
                    if (!x && !y) {
                        res *= (d + 1);
                        res %= MOD;
                    } else if (x && y) {
                        if (d % 2 == 1) {
                            res = 0;
                        }
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                swap(a[i][j], a[j][i]);
            }
        }
    }
    cout << res << "\n";

    return 0;
}